#!/usr/bin/env python2
# -*- Mode: Python; coding: utf-8; indent-tabs-mode: nil; tab-width: 4 -*-

### BEGIN LICENSE
# Copyright (C) 2010 manatlan manatlan@gmail.com
# This program is free software: you can redistribute it and/or modify it 
# under the terms of the GNU General Public License version 2, as published 
# by the Free Software Foundation.
# 
# This program is distributed in the hope that it will be useful, but 
# WITHOUT ANY WARRANTY; without even the implied warranties of 
# MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR 
# PURPOSE.  See the GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License along 
# with this program.  If not, see <http://www.gnu.org/licenses/>.
### END LICENSE

from _security import isCertOK,httpGet
import re

PEM="""-----BEGIN CERTIFICATE-----
MIIFITCCBAmgAwIBAgIDC85PMA0GCSqGSIb3DQEBBQUAMDwxCzAJBgNVBAYTAlVT
MRcwFQYDVQQKEw5HZW9UcnVzdCwgSW5jLjEUMBIGA1UEAxMLUmFwaWRTU0wgQ0Ew
HhcNMTMwNDI3MTUwMjIyWhcNMTUwNjMwMTMxMzM4WjCBuDEpMCcGA1UEBRMgblF0
YXFGR004SFNkVS9XY1dFei81a2Y1M1pDMXJoMGoxEzARBgNVBAsTCkdUNDI1NTgy
MDQxMTAvBgNVBAsTKFNlZSB3d3cucmFwaWRzc2wuY29tL3Jlc291cmNlcy9jcHMg
KGMpMTMxLzAtBgNVBAsTJkRvbWFpbiBDb250cm9sIFZhbGlkYXRlZCAtIFJhcGlk
U1NMKFIpMRIwEAYDVQQDDAkqLmZyZWUuZnIwggEiMA0GCSqGSIb3DQEBAQUAA4IB
DwAwggEKAoIBAQDFyk2w/comGiPTmjaAW+9aw+15WMw1GEgM9ONfdrXYTcCE8paq
6cEY9Xzdqa5icfG7K+9iuIM3HxFdROtsaSES8F1s2Gxf0FHb383/rFrYSp8A4PLz
fJLzoL4fp2bLDPWNhwQ9zon6Zw/dC5CiN1NcR2mOZ0ev5YVtpl2tPDOLyDXbYkSm
MdS8TlN5X5bUIStaeB1iKTajZZi0eAZfsKhU3PEiBKZY2CmB/QSpKy0EwcimlOl2
Um7uayukbtd393DKm8syzhjmhujPXnWOrYpVzliQkcXwNpHAKvTvsR8d8UWX8STB
PYeQX/irRq3hyZ6vFL54fAZzZf8+t0z1sPO/AgMBAAGjggGtMIIBqTAfBgNVHSME
GDAWgBRraT1qGEJK3Y8CZTn9NSSGeJEWMDAOBgNVHQ8BAf8EBAMCBaAwHQYDVR0l
BBYwFAYIKwYBBQUHAwEGCCsGAQUFBwMCMB0GA1UdEQQWMBSCCSouZnJlZS5mcoIH
ZnJlZS5mcjBDBgNVHR8EPDA6MDigNqA0hjJodHRwOi8vcmFwaWRzc2wtY3JsLmdl
b3RydXN0LmNvbS9jcmxzL3JhcGlkc3NsLmNybDAdBgNVHQ4EFgQUhU3IUkDnjRGJ
lUcXm7W+9tQHJcgwDAYDVR0TAQH/BAIwADB4BggrBgEFBQcBAQRsMGowLQYIKwYB
BQUHMAGGIWh0dHA6Ly9yYXBpZHNzbC1vY3NwLmdlb3RydXN0LmNvbTA5BggrBgEF
BQcwAoYtaHR0cDovL3JhcGlkc3NsLWFpYS5nZW90cnVzdC5jb20vcmFwaWRzc2wu
Y3J0MEwGA1UdIARFMEMwQQYKYIZIAYb4RQEHNjAzMDEGCCsGAQUFBwIBFiVodHRw
Oi8vd3d3Lmdlb3RydXN0LmNvbS9yZXNvdXJjZXMvY3BzMA0GCSqGSIb3DQEBBQUA
A4IBAQBX7GfK7mD7BNEPuEpSIfQZRpsmoMn85PwhVuXYX8fPiwhOwjxNWpfKqg8L
rT4ZJ6FYaTJUp8B//F03UPQW35IUpTgxtHARohJo479gxOjUNwlgAv6H+rUu/4R0
bd3LgIADaGL0akMPz619Iat5Ad/y6gIQgW/CGZhW3iNZepQpB8yjBbcQwsq8QSmS
r+RsZlXEdshdTS5aed4surS2Phlc+VCcJ69YGEaFg4+Q3Kjju1RdRVA3CUIezSV+
xA0Xds2pC3J+2LnOpSuzHWD1zucm6DijUiQBqyOycyP5yf+pZ0g22D4FFgXSPWjA
jKx7p0RggWlefkbTPOeINw/Mhp6F
-----END CERTIFICATE-----""" #('wifi.free.fr', 443)

class Wifi(object):
	name = 'freewifi'
	match = "freewifi"  # regex re.I !

	def __init__(self):
		pass

	def connectWithAuthent(self,login='',passwd=''):
		h = httpGet('http://google.com')
		if h[0] != '': 
			if h[0].lower().startswith("http://www.google."):
				return True         # already authentified !
			elif h[0].lower().startswith("https://wifi.free.fr/"):
				if isCertOK(("wifi.free.fr",443),PEM):
					d = {"login":login,
							"password":passwd,
							"submit":"Valider"
							}
					h = httpGet("https://wifi.free.fr/Auth",d)
					if h[0].lower().startswith("https://wifi.free.fr/") and "CONNEXION AU SERVICE REUSSIE" in h[1]:
						return True     # authent reached
					else:
						return False    # authent failed
				else:
					return "invalid certificat server"
			else:
				return "unknown error"
		else:
				return "dns error"

if __name__=="__main__":
	import optparse
	parser = optparse.OptionParser(version="%prog %ver")
	parser.add_option("-u", "--user", type="string", dest="user", help="User, Login, Email, ...",default="user")
	parser.add_option("-p", "--pwd", type="string", dest="pwd", help="Password",default="password")
	(options, args) = parser.parse_args()
	w=Wifi()
	print w.connectWithAuthent(options.user,options.pwd)
