#!/usr/bin/env python2
# -*- Mode: Python; coding: utf-8; indent-tabs-mode: nil; tab-width: 4 -*-

### BEGIN LICENSE
# Copyright (C) 2010 manatlan manatlan@gmail.com
# This program is free software: you can redistribute it and/or modify it 
# under the terms of the GNU General Public License version 2, as published 
# by the Free Software Foundation.
# 
# This program is distributed in the hope that it will be useful, but 
# WITHOUT ANY WARRANTY; without even the implied warranties of 
# MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR 
# PURPOSE.  See the GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License along 
# with this program.  If not, see <http://www.gnu.org/licenses/>.
### END LICENSE

from _security import isCertOK,httpGet
import re

PEM="""-----BEGIN CERTIFICATE-----
MIID8zCCAtugAwIBAgIQenEaGYzgaNbxn0Rf5lPSwzANBgkqhkiG9w0BAQUFADA8
MQswCQYDVQQGEwJVUzEVMBMGA1UEChMMVGhhd3RlLCBJbmMuMRYwFAYDVQQDEw1U
aGF3dGUgU1NMIENBMB4XDTExMTExMTAwMDAwMFoXDTE0MDIwOTIzNTk1OVowgYsx
CzAJBgNVBAYTAkZSMQ4wDAYDVQQIEwVQQVJJUzEOMAwGA1UEBxQFUEFSSVMxMDAu
BgNVBAoUJ1NPQ0lFVEUgRlJBTkNBSVNFIERVIFJBRElPVEVMRVBIT05FIFNGUjES
MBAGA1UECxQJUEZTX0ZJWEVTMRYwFAYDVQQDFA0qLndpZmkuc2ZyLmZyMIIBIjAN
BgkqhkiG9w0BAQEFAAOCAQ8AMIIBCgKCAQEA0F1fi1efeO/jKdyDH4noexNglDXM
pHM6Tp1vaHN1wvNOT8BXXIYdrAL2B/UEVhoauoSmMVXod3WXelrSE4cVwQd57rJM
3aKRtNTNmiDxyWR58lmaiwf7K6yR7J0y1mnPCC0Cmn8/cEyHLx0A26Nd+cZJzgKD
3neTXF6lmCEgOqgzWvMbM+o6ggqQKD3UlnX+0h9yXnZEuUpCZzvXstXePSvctsob
DV5p7BTAMicT1furZnvmR7pPi1EBgmEwLEM/z/LcuLhMB+/whCKURdNDzFqI/tfL
lP+99Gz3XotFwG+FjKBtsB7afMVOrwBPNrHIiuP0w57EFnaJy127yV/ecQIDAQAB
o4GgMIGdMAwGA1UdEwEB/wQCMAAwOgYDVR0fBDMwMTAvoC2gK4YpaHR0cDovL3N2
ci1vdi1jcmwudGhhd3RlLmNvbS9UaGF3dGVPVi5jcmwwHQYDVR0lBBYwFAYIKwYB
BQUHAwEGCCsGAQUFBwMCMDIGCCsGAQUFBwEBBCYwJDAiBggrBgEFBQcwAYYWaHR0
cDovL29jc3AudGhhd3RlLmNvbTANBgkqhkiG9w0BAQUFAAOCAQEAMvASjzyazfYP
Dp/GfaKfZr/n3Yz9gozhmyhhAoC+JN+kPhPfVqIuajjOI+Ztpn6eiv55V2m+TEG/
jbR7gLHoVR5s3pendkjLjVOsiVR4+YRxS/tXiQ7IfS7w/gG8JiZ3c3Epzmm0NE52
XOuE5JukBKuiHUwYf2f2fdIhlFE6Al5BGEJOQ+c767ZUxfJYEYBFE03TvGAySlbT
nsIhxFyaNY2ArFJ3sogsWztQ4vGtec+/mn2mmYURI8twAwBBjsMyjkCg37sJq5IJ
k/xaY8ktcncwtr8CXToUtvHt2Rm3aNE1vOr/TsAwWTMZ7gxbarrAGWTrOICQSZpu
/Yw7c8dNRg==
-----END CERTIFICATE-----""" #('hotspot.wifi.sfr.fr', 443)

class Wifi(object):
	name = 'sfrfon'
	match = "^SFR WiFi (FON|Public)$" # a regex which match a ssid (re.I) !

	def __init__(self):
		pass

	def connectWithAuthent(self,login='',password=''):
		h = httpGet('http://google.com')
		if h[0] != '':
			if h[0].lower().startswith("http://www.google."):
				return True # already connected
			elif h[0].lower().startswith("https://hotspot.wifi.sfr.fr"):
				if isCertOK(("hotspot.wifi.sfr.fr",443),PEM):
					h=h[1]
					d={
						"lang":"fr",
						"username":login,
						"username2":login,
						"password":password,
						"conditions":"on",
						"mode":re.search('mode=([^\&]*)',h).group(1),
						"accessType":"neuf",
						"choix":"neuf",
						"uamip":re.search('uamip=([^\&]*)',h).group(1),
						"uamport":re.search('uamport=([^\&]*)',h).group(1),
						"channel":re.search('channel=([^-]*)',h).group(1),
						"connexion":"Connexion",
						"save":"on",
						"mac":re.search('mac=([^\&]*)',h).group(1)+"|"+re.search('nasid=([^\&]*)',h).group(1),
						"userurl":'http://sfr.fr',
						"challenge":re.search('challenge=([^\&]*)',h).group(1),
					}
					print d
					h=httpGet("https://hotspot.wifi.sfr.fr/nb4_crypt.php",d)
					redirect=re.search('window.location = "(http[^\"]+)"',h[1]).group(1)
					h = httpGet(redirect)
					if "res=success"in h[0] or "res=already" in h[0]:
						return True
					else:
						return False # authent failed
				else:
					return "invalid certificat server"
			else:
				return "Unknown error"
		else:
				return "dns error"

if __name__=="__main__":
	import optparse
	parser = optparse.OptionParser(version="%prog %ver")
	parser.add_option("-u", "--user", type="string", dest="user", help="User, Login, Email, ...",default="user")
	parser.add_option("-p", "--pwd", type="string", dest="pwd", help="Password",default="password")
	(options, args) = parser.parse_args()
	w=Wifi()
	print w.connectWithAuthent(options.user,options.pwd)
