#!/usr/bin/env python
# -*- Mode: Python; coding: utf-8; indent-tabs-mode: nil; tab-width: 4 -*-

### BEGIN LICENSE
# Copyright (C) 2010 manatlan manatlan@gmail.com
# This program is free software: you can redistribute it and/or modify it 
# under the terms of the GNU General Public License version 2, as published 
# by the Free Software Foundation.
# 
# This program is distributed in the hope that it will be useful, but 
# WITHOUT ANY WARRANTY; without even the implied warranties of 
# MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR 
# PURPOSE.  See the GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License along 
# with this program.  If not, see <http://www.gnu.org/licenses/>.
### END LICENSE

import dbus
from dbus.mainloop.glib import DBusGMainLoop

class NetMan(object):
	def __init__(self):
		loop = DBusGMainLoop()
		self.bus = dbus.SystemBus(mainloop=loop)
		self.nmi = dbus.Interface(self.bus.get_object('org.wicd.daemon', '/org/wicd/daemon'), 'org.wicd.daemon')
		self.nmi.connect_to_signal('ConnectResultsSent', self._on_properties_changed)
		self.ssid = self.getCurrentSSID()
	def _on_properties_changed(self,ret):
		if ret == "success":
			ssid = self.getCurrentSSID()
			if self.ssid != ssid:
				self.ssid=ssid
				self.on_ssid_changed(self.ssid)

	def on_ssid_changed(self,ssid):
		pass

	def getCurrentSSID(self):
		ssid = self.bus.get_object('org.wicd.daemon','/org/wicd/daemon/wireless').GetCurrentNetwork()
		if ssid == "off/any":
			ssid = ""
		return ssid

if __name__ == "__main__":
	n=NetMan()
	print n.getCurrentSSID()
